<template>
  <slot :is-unread-last-message="isUnreadLastMessage" />
</template>

<script setup lang="ts">
import { computed, PropType } from 'vue';
import { storeToRefs } from 'pinia';
import { useUserStore } from '@new-jira-clone/libs/src/store';
import { IChat, MessageTypes } from '@/shared';
import { useConversationDetailsService } from '@/entities/Conversation';

const props = defineProps({
  chat: {
    type: Object as PropType<IChat>,
    required: true,
  },
  isActive: {
    type: Boolean,
    default: true,
  },
});

const { getUser } = storeToRefs(useUserStore());
const { getChatDetails } = useConversationDetailsService();

const isScrollAtBottom = computed(() => getChatDetails(props.chat.id)?.isScrollAtBottom);

const isUnreadLastMessage = computed(() => {
  if (isScrollAtBottom.value === true && props.isActive) return false;
  if (props.chat.lastMessage === null) return false;
  if (
    props.chat.lastMessage.author.id === getUser.value?.id &&
    props.chat.lastMessage.type !== MessageTypes.CreateGroup
  ) return false;
  if (props.chat.lastRead === null) return true;

  const lastRead = new Date(props.chat.lastRead ?? '');
  const lastMessageCreatedAt = new Date(props.chat.lastMessage.createdAt);

  return lastRead < lastMessageCreatedAt;
});
</script>
